%% Facility Location Problem (see p.71) - Movie

%%
clear all, clf
syms x y
r1 = sqrt((x-1)^2+(y-5)^2)^0.91;
r2 = sqrt((x-3)^2+(y-5)^2)^0.91;
r3 = sqrt((x-5)^2+(y-5)^2)^0.91;
r4 = sqrt((x-1)^2+(y-3)^2)^0.91;
r5 = sqrt((x-3)^2+(y-3)^2)^0.91;
r6 = sqrt((x-5)^2+(y-3)^2)^0.91;
r7 = sqrt((x-1)^2+(y-1)^2)^0.91;
r8 = sqrt((x-3)^2+(y-1)^2)^0.91;
r9 = sqrt((x-5)^2+(y-1)^2)^0.91;

z = 3.2+1.7*(6*r1+8*r2+8*r3+21*r4+6*r5+3*r6+18*r7+8*r8+6*r9)/84;
ezcontourf(z,[0 6 0 6])
colorbar, grid on
hold on

F = diff(z,x); G = diff(z,y);
a=0; b=6; c=0; d=6; % boundaries of the (x,y) domain
N=100; % Number of points
rs=moviein(N);

x0 = a+(b-a)*rand(1);
y0 = c+(d-c)*rand(1);
zmin = subs(z,[x,y],[x0,y0]);

fprintf(' Iteration    z value\n\n');
for n=1:N
    xnew=a+(b-a)*rand(1);
    ynew=c+(d-c)*rand(1);
    znew=subs(z,[x,y],[xnew,ynew]); 
    plot3(xnew,ynew,znew, 'mo',...
                'LineWidth',1,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',4);
    if znew<zmin
        xmin=xnew;
        ymin=ynew;
        zmin=znew;
        fprintf('%4.0f %1.10f\n', n, zmin);
        ezcontourf(z,[0 6 0 6])
        colorbar, grid on
        plot3(xnew,ynew,znew, 'mo',...
                'LineWidth',1,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','r',...
                'MarkerSize',8);
        hold on    
    end
    rs(:,n) = getframe;
end

xmin,ymin
plot3(xmin,ymin,zmin, 'mo',...
                'LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',12);
title('Countour plot and optimal value');

zmin