%% Math 448/548 - Example 6.1 - War Problem 
% This Matlab code illustrates the dependence on paramenter analysis for a 
% discrete dymanical system via repeated simulations.

clear all, close all, clc

endtime = []; winner = [];
values = [1 1.5 2 3 5 6]; % choose a set of values for lambda

%%
% Plot the direction field (no rescaling!)

for lambda = values
    a2=0.05; b2=0.005;
    a1=lambda*a2; b1 =lambda*b2;
    
    figure
    M=10; % number of samples points
    x1min=0; x1max=5; % domain specification
    x2min=0; x2max=2; 
    [X1,X2]=meshgrid(x1min:(x1max-x1min)/M:x1max,x2min:(x2max-x2min)/M:x2max);
    dX1=-a1*X2-b1*X1.*X2; % x1-component
    dX2=-a2*X1-b2*X1.*X2;         % x2-component
    quiver(X1,X2,dX1,dX2,0); % matlab routine
    axis([x1min x1max x2min x2max]);
    hold on
    xlabel('Red Army'); ylabel('Blue Army');

    x=[5;2];
    n=1;
    sprintf(strcat('Battle evolution for lambda =',num2str(lambda),'\n'))
    fprintf('n    Red Army    Blue Army  \n')
    fprintf('%2.0f      %5.2f        %5.2f\n', 0, x(1), x(2))

    while x(1)>0 & x(2)>0
        n=n+1;
        rhs = [ -a1*x(2)-b1*x(1)*x(2);
                -a2*x(1)-b2*x(1)*x(2)];
        xnew = x + rhs;
        plot([x(1),xnew(1)], [x(2),xnew(2)],'--ro',...
        'MarkerFaceColor','k','MarkerSize',4)
        x = xnew;
        fprintf('%2.0f      %5.2f        %5.2f\n', n, x(1), x(2)) 
    end
    if x(1)>0 winner = [winner,1];
        else winner = [winner,2]; 
    end 
    title(strcat('Battle outcome for \lambda =',num2str(lambda)))
    xlabel('Red Army'); ylabel('Blue Army');
    endtime = [endtime n];
end

%endtime=endtime(2:end);
%%

disp('lambda    battle length    winner')
disp([values' endtime' winner'])